Package com.xebialabs.xlrelease.repository

## Class CiProperty

- java.lang.Object
- - com.xebialabs.xlrelease.repository.CiProperty

-     public abstract class CiProperty
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `CiProperty​(ConfigurationItem rootCi, java.lang.String fqPropertyExpression)` |
    `protected` | `CiProperty​(CiProperty wrapped)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `exists()` |
    `java.lang.String` | `getCategory()` |
    `PropertyDescriptor` | `getDescriptor()` |
    `PropertyKind` | `getKind()` |
    `ConfigurationItem` | `getParentCi()` |
    `java.lang.String` | `getPropertyName()` |
    `<T> T` | `getValue()` |
    `boolean` | `isIndexed()` |
    `boolean` | `isPassword()` |
    `static java.util.Optional<CiProperty>` | `of​(ConfigurationItem rootCi, java.lang.String fqPropertyExpression)` |
    `protected abstract void` | `replaceInStrings​(java.lang.String variableKey, java.lang.String replacement)` |
    `void` | `replaceInValue​(Variable variable, VariableOrValue replacement)` |
    `void` | `setValue​(java.lang.Object value)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CiProperty

          protected CiProperty​(CiProperty wrapped)

    - #### CiProperty

          protected CiProperty​(ConfigurationItem rootCi,
                               java.lang.String fqPropertyExpression)

  - ### Method Detail

    - #### of

          public static java.util.Optional<CiProperty> of​(ConfigurationItem rootCi,
                                                          java.lang.String fqPropertyExpression)

    - #### getPropertyName

          public java.lang.String getPropertyName()

    - #### getValue

          public <T> T getValue()

    - #### setValue

          public void setValue​(java.lang.Object value)

    - #### getParentCi

          public ConfigurationItem getParentCi()

    - #### getDescriptor

          public PropertyDescriptor getDescriptor()

    - #### getKind

          public PropertyKind getKind()

    - #### getCategory

          public java.lang.String getCategory()

    - #### isPassword

          public boolean isPassword()

    - #### isIndexed

          public boolean isIndexed()

    - #### exists

          public boolean exists()

    - #### replaceInValue

          public void replaceInValue​(Variable variable,
                                     VariableOrValue replacement)

    - #### replaceInStrings

          protected abstract void replaceInStrings​(java.lang.String variableKey,
                                                   java.lang.String replacement)